import { add, defn, mul, ret, sub, sym, } from "@thi.ng/shader-ast";
const $ = (n, type) => defn(type, `mixQuadratic${n > 1 ? n : ""}`, [type, type, type, "float"], (a, b, c, t) => {
    let s;
    return [
        (s = sym(sub(1, t))),
        ret(add(add(mul(a, mul(s, s)), mul(b, mul(2, mul(s, t)))), mul(c, mul(t, t)))),
    ];
});
export const mixQuadratic = $(1, "float");
export const mixQuadratic2 = $(2, "vec2");
export const mixQuadratic3 = $(3, "vec3");
export const mixQuadratic4 = $(4, "vec4");
