import { add, defn, float, FLOAT1, mod, mul, ret, } from "@thi.ng/shader-ast";
const __permute = (type, suffix = "") => defn(type, `permute${suffix}`, [type], (v) => [
    ret(mod(mul(v, add(mul(v, float(34)), FLOAT1)), float(289))),
]);
export const permute = __permute("float");
export const permute2 = __permute("vec2", "2");
export const permute3 = __permute("vec3", "3");
export const permute4 = __permute("vec4", "4");
